Ruby master - Bug #8995

gooooooooooooD encode! 000 readbyte 00000000
10/08/2013 04:49 PM - hsbt (Hiroshi SHIBATA)

Status: Third Party's Issue

Priority: Normal

Assignee:

Target version: 21.0

ruby -v: ruby 2.1.0dev (2013-10-07 trunk 43160) |Backport:
[x86_64-darwin12.5.0]

1.9.3: UNKNOWN, 2.0.0: UNKNOWN

Description

=begin
Rails 00000000000 2.0 0 2.1 0000000000

)
g0ooooooooo

$ ruby -v
=> ruby 2.1.0dev (2013-10-07 trunk 43160) [x86_64-darwin12.5.0]

$ ruby -rstringio -e "Encoding.default_internal = Encoding::UTF_8; p StringlO.new(File.read('x.jpg')).readbyte"”

=> 255

$ ruby -rstringio -e "Encoding.default_internal = Encoding::UTF_8; p
StringlO.new(File.read('x.jpg').force_encoding('UTF-8').encode!).readbyte”
=> 239

0002.0 00OODOODOODOODOODOD

$ ruby -v
=> ruby 2.0.0p326 (2013-10-05 revision 43144) [x86_64-darwin13.0.0]

$ ruby -rstringio -e "Encoding.default_internal = Encoding::UTF_8; p StringlO.new(File.read('x.jpg')).readbyte"

=> 255

$ ruby -rstringio -e "Encoding.default_internal = Encoding::UTF_8; p
StringlO.new(File.read('x.jpg').force_encoding('UTF-8').encode!).readbyte”

=> 255

rails 000000 rails4 000000000000000000000 post 0O00000DDOOOOOOOOODODODD

rails [00000000000File.binread 0000000000000000000000000D0OC0DODO

=end

Associated revisions

Revision 95a6be1a - 11/22/2013 08:50 AM - naruse (Yui NARUSE)

e transcode.c (str_transcode0): don't scrub invalid chars if str.encode doesn't have explicit invalid:

git-svn-id: svn+ssh://ci.ruby-lang.org/ruby/trunk@43802 b2dd03c8-39d4-4d8f-98ff-823fe69b080e

Revision 43802 - 11/22/2013 08:50 AM - naruse (Yui NARUSE)

e transcode.c (str_transcode0): don't scrub invalid chars if str.encode doesn't have explicit invalid:
e transcode.c (str_transcode0): don't scrub invalid chars if str.encode doesn't have explicit invalid:
History

#1 - 10/08/2013 05:11 PM - nobu (Nobuyoshi Nakada)

=begin

[I[I[I[I[I[I[I[I[I[I[I[I[I[I[I

$ ruby -E:UTF-8 -e 'p "\xff".encode.unpack("C*"

239, 191 189|]|]DI]DI]DI]DI]DI]DDDDDDDDDDDDDDDDDDDDDDDDD

=end

#2 - 10/08/2013 07:01 PM - hsbt (Hiroshi SHIBATA)
- Category set to core

- Target version set to 2.1.0

#3 - 10/08/2013 10:18 PM - nobu (Nobuyoshi Nakada)
- Description updated

=begin

[I[I[Ir40390|]|]|]

* transcode.c (str_transcode0): If invalid: :replace is specified for
String#encode, replace invalid byte sequence even if the destination
encoding equals to the source encoding.

(fencode_params)))0000HTTPOOOO0O00000000000000000000000000O00D000O00O00DO000((valid_encoding})l0O00((tASCI-8BIT})IOOOD
DDDDDDDDDDDDDDDDDD

=end

#4 - 10/08/2013 11:06 PM - nobu (Nobuyoshi Nakada)
- Status changed from Open to Third Party's Issue

00000DoDoDoooononODoDoDODoDoDO0o0nanang

#5 - 10/08/2013 11:14 PM - hsbt (Hiroshi SHIBATA)
rails 000000 rails 3 000000000000000invaria O utt-s 0000000000000000000000000000000000000000rails DODODOOOODODODODO

#6 - 10/08/2013 11:34 PM - nobu (Nobuyoshi Nakada)
00000000000000000000000000000DO000D0O000D0O000DoO0n

#7 - 10/10/2013 10:56 AM - naruse (Yui NARUSE)
aoonooooooon

return params.force_encoding("UTF-8").encode!
HHHDDDDDDDDDDDDDDDDD

return params.force_encoding("UTF-16").encode!

00000000 ruby 2.1 DODOOOODODODO

000000000000000
0000o00o00DooDo0DAscn-saiTl0DO0DOODDOODOODOODEOD

#8 - 11/23/2013 11:34 AM - nobu (Nobuyoshi Nakada)
(%7BEncoding.default_internal%7D)

workaround(00000000000uTr-80000000000000000000000000000matformed UTF-8000000000000000000000
000000oooboonoonoonDannoonoonDo0noo0Dha0DO0DDO0DOnD
